#include "descriptor/descriptor.h"


int main (void) {

/*******************************************************************************************************/
/* 	Superfici ITEM 						                	       	       */
	ITEM pezzo0_1, pezzo1, pezzo2;									/*Corpo*/
	ITEM aloCentrale_Piccolo, aloDestro_PIccolo, aloSinistro_Piccolo;				/*AliPiccoli*/
	ITEM aloDestro, aloSinistro, bordo_ali;								/*Ali*/
	ITEM finestra_0_, finestra_1_, finestra_2_, vetro_avanti;					/*Finestre*/
	ITEM luce_alo_destro, luce_alo_sinistro, luce_centro_alto, luce_terminale, luce_centro_sotto;	/*Lucine*/
	ITEM piede_1_destro, piede_2_destro, piede_1_sinistro, piede_2_sinistro;			/*Piedini*/
	ITEM piede_avanti, piede_centrale, piede_destro, piede_sinistro;				/*Piedi*/
	ITEM ruota_1,ruota_2, ruota_avanti_1, ruota_avanti_2, ruota_destra_1, 				/*Ruote*/
     	ruota_destra_2, ruota_sinistra_1, ruota_sinistra_2;					
	ITEM turbina_1_destra, turbina_2_destra, turbina_1_sinistra,turbina_2_sinistra, turbina_dietro; /*Turbine*/
	ITEM piano,sky,sky1,sfera_cielo, pista,pista2, muro ;						/*Ambiente*/
	ITEM terminale_base, terminale_alto,tetto_basse,tetto, 
	     antena,palazzo1, palazzo2,palazzo3, capanone2, capanone;     				/*Strutture*/
	
	ITEM scena, cielo, Cielo, Corpo, Ali, AliPiccoli, Lucine, Piedini, Piedi, Ruote, Turbine, Terra, 
	     Finestre, Piano, Strutture, Terminale,Capanoni,Palazzi,Tetto, Volo, Cielo1, Magazzino;
	
	ITEM piede_sinistro_volo, piede_destro_volo, piede_centrale_volo, piede_avanti_volo ;
	ITEM muri_magazino_tetto, muri_magazino;

/************************************************************************************************/
/* 	File .obj */
	ITEM Dinamica, Dinamica_texture, A340_600_texture, A340_600, Turbine_texture, Ruote_texture, Luci_aereo, finestre1, 		     Piedini_terra,Piedi_terra;
/************************************************************************************************/
/*	Attributi ITEM 										*/
	ITEM ferro, nero, nero1, lucerossa, attributo_cielo, finestre;

	set_background(1,1,0.953,FALSE);
	set_ambient_light(0.77,1,1,4.333);
	//create_point_light(71.522, 3.500, -51.553, 1, 1, 0.439, 1, 0, "Light_Terra");
	create_point_light(-66.269, 5.596, 22.007, 1, 1, 0.514, 1, 0, "Light_Basso");
	//create_point_light(35.239, -169.793, 3.581, 1, 1, 0.514, 1, 0, "Light_Anteriore");
	create_point_light(-12.053, 17.318, 7.381, 1, 1, 0.514, 1, 0, "Light_SX");	
	create_point_light(-68.509, -57.500,91.923, 1, 1, 0.439, 1, 1, "Light_Cielo");

/************************************************************************************************/
/* 	Deffinizioni dei Attributi 								*/

/************************************************************************************************/
/* 	Cielo											*/
	attributo_cielo = create_attribute("materiale_cielo");
	set_color(attributo_cielo, 0.773, 0.929, 0.988, 0.9, 0.9);
	set_transparency(attributo_cielo, 0, 0, 0, 2);

/************************************************************************************************/
/*	Finestre 										*/
	finestre=create_attribute("finestre");
        set_color(finestre, 0.745, 1, 0.929, 0.28, 0.734);
        set_reflectivity(finestre, 0.22, 2);
        set_transparency(finestre, 0.86, 0.61, 2, 1);

/************************************************************************************************/
/*	Nero 	 										*/
	nero=create_attribute("nero");
        set_color(nero, 0, 0, 0, 0.16, 0.853);
        set_reflectivity(nero, 0.11, 2);
        set_transparency(nero, 0, 0, 0, 1);

/************************************************************************************************/
/*	Nero Scuro										*/

	nero1 = create_attribute("nero1");
  	set_color(nero1, 0.7, 0.7, 0.7, 0.7, 0.1);
  	set_reflectivity(nero1, 0.4, 1.5);

/************************************************************************************************/
/*	Ferro											*/
	ferro = create_attribute("ferro");
	set_color(ferro, 1,1,1,0.8,0.7);
	set_reflectivity(ferro, 0.4,1.5);

/************************************************************************************************/
/*	Lucerossa 									        */	     		
	lucerossa=create_attribute("lucerossa");
	set_color(lucerossa, 1, 0.07, 0.07, 0.69, 0.899);	
	set_reflectivity(lucerossa, 0.8, 1);
	set_transparency(lucerossa, 0.7, 0.5, 1, 1.5);

	
/************************************************************************************************/
/*	Oggeti e deffinizione delle scene							*/
/************************************************************************************************/
/*	Lucine 											*/
	luce_alo_destro=read_nurbs("luce_alo_destro.db");
	luce_alo_sinistro=read_nurbs("luce_alo_sinistro.db");
	luce_centro_alto=read_nurbs("luce_centro_alto.db");
	luce_centro_sotto=read_nurbs("luce_centro_sotto.db");
	set_attribute(luce_alo_destro, lucerossa);
	set_attribute(luce_alo_sinistro, lucerossa);
	set_attribute(luce_centro_alto, lucerossa);
	set_attribute(luce_centro_sotto, lucerossa);
	Lucine = create_list(luce_alo_destro,"Lucine");
	Lucine = insert_in_list(Lucine, luce_alo_sinistro);
	Lucine = insert_in_list(Lucine, luce_centro_alto);
	Lucine = insert_in_list(Lucine, luce_centro_sotto);
	scena = create_list(Lucine, "scena");	

/************************************************************************************************/
/* 	Piano											*/
	piano=read_nurbs("piano.db");
	set_scale(piano , 1000, 1000, 1000);
	set_domain_texture(piano,nero,"textures/erba1.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	piano = create_list(piano, "Piano");
	scena = insert_in_list(scena, Piano);

/************************************************************************************************/
/* 	Strutture										*/
/************************************************************************************************/
	antena=read_nurbs("antena.db");
	set_attribute(antena, nero);
	Strutture = create_list(antena, "Strutture");
	scena = insert_in_list(scena, Strutture);

	terminale_base = read_nurbs("terminale_base.db");
	terminale_alto = read_nurbs("terminale_alto.db");
	set_domain_texture(terminale_base,nero,"textures/palazzi.hr",1,1.5,1,1.5,TRUE,0.2,0.2);
	set_domain_texture(terminale_alto,finestre ,"textures/piano.hr",1,1.5,1,1.5,TRUE,0.2,0.2);
	Terminale = create_list(terminale_base,"Terminale");
	Terminale = insert_in_list(Terminale, terminale_alto);
	scena = insert_in_list(scena, Terminale);

	tetto_basse = read_nurbs("tetto_basse.db");
	tetto 	    = read_nurbs("tetto.db");
	set_attribute(tetto_basse, nero);
	set_attribute(tetto, nero);
	Tetto = create_list(tetto_basse, "Tetto");
	Tetto = insert_in_list(Tetto, tetto);
	scena = insert_in_list(scena, Tetto);

	luce_terminale=read_nurbs("luce_terminale.db");
	set_attribute(luce_terminale, lucerossa);
	Lucine = insert_in_list(Lucine, luce_terminale);
	scena = insert_in_list(scena, Lucine);

/************************************************************************************************/
/*	Ambiente										*/	
	capanone=read_nurbs("capanone.db");
	capanone2=read_nurbs("capanone2.db");
	set_domain_texture(capanone,nero,"textures/piano.hr",1,1.5,1,1.5,TRUE,0.2,0.2);
	set_domain_texture(capanone2, nero,"textures/piano.hr",0.1,0.5,0.1,0.5,TRUE,0.2,0.2);
	Capanoni = create_list(capanone,"Capanoni");
	Capanoni = insert_in_list(Capanoni, capanone2);
	scena = insert_in_list(scena, Capanoni);
	
	palazzo1 = read_nurbs("palazzo1.db");
	palazzo2 = read_nurbs("palazzo2.db");
	palazzo3 = read_nurbs("palazzo3.db");
	set_domain_texture(palazzo1, nero,"textures/palazzi1.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	set_domain_texture(palazzo2, nero,"textures/palazzi1.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	set_domain_texture(palazzo3, nero,"textures/palazzi1.hr",1,1.5,1,1.5,TRUE,0.1,0.1);	
 	Palazzi = create_list(palazzo1, "Palazzi");
	Palazzi = insert_in_list(Palazzi, palazzo2);
	Palazzi = insert_in_list(Palazzi, palazzo3);
	scena = insert_in_list(scena, Palazzi);

/************************************************************************************************/
/*	Terra 											*/
	pista=read_nurbs("pista.db");
	pista2=read_nurbs("pista2.db");
	muro=read_nurbs("muro.db");
	set_domain_texture(pista, nero,"textures/piano.hr",0.1,0.5,0.1,0.5,TRUE,0.1,0.1);
	set_domain_texture(pista2, nero, "textures/piano.hr",0.1,0.5,0.1,0.5,TRUE,0.1,0.1);
	set_bump_texture(muro, nero, "textures/muro.hr",0.1,0.5,0.3,0.5,TRUE,0.1,0.1);	
	Terra = create_list(pista, "Terra");
	Terra = insert_in_list(Terra, pista2);
	Terra = insert_in_list(Terra, muro);
	scena = insert_in_list(scena, Terra);	

/*==============================================================================================*/
/* 	A340_600 in volo									*/
/* 	Per fare le rese del mio modello A340_600 in volo basta mettere sotto comento le  
	seguenti Strutture.
	--Piedi
	--Ruote
	--Terra
	--Capanoni
	--Magazino
	--Palazzi
	--Terminale
	--Spostare di -20.000 l'asse Z cosi 
*/

/************************************************************************************************/
/* 	Sky												*/	
	sky=read_nurbs("sky.db");
	set_scale(sky , 1000, 1000, 1000);
	set_domain_texture(sky ,attributo_cielo,"textures/sky.hr",0.5,1,0.5,1,TRUE,0.1,0.1);
	piano = create_list(sky, "Cielo");
	scena = insert_in_list(scena, Cielo);	

	sky1=read_nurbs("sky1.db");
	set_scale(sky1, 1000, 1000, 1000);
	set_domain_texture(sky1 ,attributo_cielo,"textures/sky.hr",0.5,1,0.5,1,TRUE,0.1,0.1);
	Cielo = create_list(sky1, "Cielo1");
   	scena = insert_in_list(scena, Cielo1);

	
/************************************************************************************************/
/*	Piedini_volo											*/
	piede_sinistro_volo=read_nurbs("piede_sinistro_volo.db");
	piede_destro_volo=read_nurbs("piede_destro_volo.db");
	piede_centrale_volo=read_nurbs("piede_centrale_volo.db");
	piede_avanti_volo=read_nurbs("piede_avanti_volo.db");
	set_attribute(piede_sinistro_volo, nero);
	set_attribute(piede_destro_volo, nero);
	set_attribute(piede_centrale_volo, nero);
	set_attribute(piede_avanti_volo, nero);
	Volo = create_list(piede_sinistro_volo,"Volo" );
	Volo = insert_in_list(Volo, piede_destro_volo);
	Volo = insert_in_list(Volo, piede_centrale_volo);
	Volo = insert_in_list(Volo, piede_avanti_volo);
	scena = insert_in_list(scena, Volo);
	
/************************************************************************************************/
/*	Turbina_Dietro												*/	
	turbina_dietro=read_nurbs("turbina_dietro.db");
	set_attribute(turbina_dietro, nero);
	Turbine = create_list( turbina_dietro, "Turbine");
	scena = insert_in_list(scena, Turbine);

/************************************************************************************************/
/*      A340_600_texture.0bj											*/
	A340_600_texture =read_obj("A340_600_texture.obj", "A340_600_texture");
	set_domain_texture(A340_600_texture, ferro, "textures/corpo.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	A340_600=create_list( A340_600_texture, "A340_600");
	scena=insert_in_list(scena , A340_600);	

/************************************************************************************************/
/*	Dinamica_texture.obj											*/
	Dinamica=read_obj("Dinamica_texture.obj", "Dinamica");
	set_attribute(Dinamica, nero);
	Dinamica_texture= create_list(Dinamica, "Dinamica_texture");
	scena = insert_in_list(scena, Dinamica_texture);

/************************************************************************************************/
/*      Turbine_texture.obj											*/
	Turbine_texture=read_obj("Turbine_texture.obj", "Turbine_texture");
	set_domain_texture(Turbine_texture, ferro, "textures/bandiera1.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	Turbine = create_list(Turbine, "Turbine_texture");
	scena = insert_in_list(scena , Turbine_texture);

/************************************************************************************************/
/*	Finestre1_texture.obj											*/
	finestre1=read_obj("Finestre1_texture.obj","finestre1");
	set_attribute(finestre1, nero);
	Finestre = create_list(finestre1, "Finestre");
	scena = insert_in_list(scena, Finestre);	

/************************************************************************************************/
/*	Bandiera												*/	
	aloCentrale_Piccolo=read_nurbs("aloCentrale_Piccolo.db");
	set_domain_texture(aloCentrale_Piccolo,nero,"textures/bandiera1.hr",1,1.5,1,1.5,TRUE,0.2,0.2);
	AliPiccoli = create_list(aloCentrale_Piccolo,"AliPiccoli");
	scena = insert_in_list(scena,AliPiccoli);

/************************************************************************************************/
/*	Piedi.obj										*/
/*	Piedini_terra=read_obj("Piedini.obj", "Piedini_terra");
	set_domain_texture(Piedini_terra, ferro, "textures/corpo.hr",1,1.5,1,1.5,TRUE,0.1,0.1);
	Piedi_terra = create_list(Piedini_terra, "Piedi_terra");
	scena = insert_in_list(scena, Piedi_terra);
*/
/************************************************************************************************/
/*	Ruote.obj												*/
/*	Ruote_texture =read_obj("Ruote.obj", "Ruote_texture");
	set_attribute(Ruote_texture, nero);
	Ruote = create_list(Ruote_texture, "Ruote");
	scena = insert_in_list(scena, Ruote); 
*/
/************************************************************************************************/
/* 	Luci.obj												*/
/*	Luci_aereo=read_obj("Luci.obj", "Luci_aereo");
	set_attribute(Luci_aereo, lucerossa);
	Lucine = create_list(Luci_aereo, "Lucine");
	scena = insert_in_list(scena, Lucine);
*/
save_scene("A340_600.md","A340_600",scena);

/*int i;
for(i=0;i<10;i++)
{
	save_scene_ani(10,"A340_600.ani","A340_600","scena_A340_600", 
scena);
}*/

return(0);
}

